/* Bspl069.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int verglplz(const void *, const void *);
int verglort(const void *, const void *);

struct ort {
	int plz;
	char ort [26];
};


int main() {

	struct ort ortliste[] = {{45466, "Mlheim"},
		{52349, "Dren"}, {53119, "Bonn"}}; 
	struct ort suchbegr;
	struct ort *ergebnis;

	printf("\n\nSuche PLZ: ");
	scanf("%i", &suchbegr.plz);
	qsort((void *)ortliste, sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglplz);
	ergebnis = (struct ort *)bsearch((void*)&suchbegr, (void *)ortliste,
		sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglplz);
	if (ergebnis != NULL) {
		printf("\nPLZ %i gehrt zu %s.", suchbegr.plz, ergebnis->ort);
	}
	else
		printf("\nNichts gefunden.");

	printf("\n\nSuche Ort: ");
	scanf("%s", &suchbegr.ort);
	qsort((void *)ortliste, sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglort);
	ergebnis = (struct ort *)bsearch((void*)&suchbegr, (void *)ortliste,
		sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglort);
	if (ergebnis != NULL) {
		printf("\n%s hat PLZ %i.", suchbegr.ort, ergebnis->plz);
	}
	else
		printf("\nNichts gefunden.");

	printf("\n");
	return 0;
}

int verglplz(const void *el1, const void *el2) {
	struct ort *p1 = (struct ort *)el1;
	struct ort *p2 = (struct ort *)el2;

	if (p1->plz > p2->plz)
		return 1;
	else if (p1->plz < p2->plz)
		return -1;
	else
		return 0;	
}

int verglort(const void *el1, const void *el2) {
	struct ort *p1 = (struct ort *)el1;
	struct ort *p2 = (struct ort *)el2;

	return strcmp(p1->ort, p2->ort);
}
